unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TformMenuPrincipal = class(TForm)
    bGuardarImagen: TButton;
    dlGuardar: TSaveDialog;
    bIniciarCamara: TButton;
    pImagen: TPanel;
    StaticText1: TStaticText;
    bGuardarVideo: TButton;
    bDetener: TButton;
    bCapturarFrame: TButton;
    bCerrar: TButton;
    procedure FormCreate(Sender: TObject);
    procedure bGuardarImagenClick(Sender: TObject);
    procedure bIniciarCamaraClick(Sender: TObject);
    procedure bGuardarVideoClick(Sender: TObject);
    procedure bDetenerClick(Sender: TObject);
    procedure bCapturarFrameClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bCerrarClick(Sender: TObject);
  private
    { Private declarations }
    idResultado : THandle;
    capturandoAVI : Boolean;

  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

  const WM_CAP_START = WM_USER;
  const WM_CAP_STOP = WM_CAP_START + 68;
  const WM_CAP_DRIVER_CONNECT = WM_CAP_START + 10;
  const WM_CAP_DRIVER_DISCONNECT = WM_CAP_START + 11;
  const WM_CAP_SAVEDIB = WM_CAP_START + 25;
  const WM_CAP_GRAB_FRAME = WM_CAP_START + 60;
  const WM_CAP_SEQUENCE = WM_CAP_START + 62;
  const WM_CAP_FILE_SET_CAPTURE_FILEA = WM_CAP_START + 20;
  
  function capCreateCaptureWindowA(lpszWindowName : PCHAR;
      dwStyle : longint; x : integer; y : integer; nWidth : integer;
      nHeight : integer; ParentWin : HWND; nId : integer): HWND; stdcall external 'AVICAP32.DLL';

{


procedure TForm1.StopAVIClick(Sender: TObject);

begin

  if hWndC <> 0 then begin

  SendMessage(hWndC, WM_CAP_STOP, 0, 0);

  CapturingAVI := false;

  end;

end;
                }


procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  capturandoAVI := false;
  idResultado := 0;
  dlGuardar.Options :=  [ofHideReadOnly, ofNoChangeDir, ofPathMustExist];
end;

procedure TformMenuPrincipal.bGuardarImagenClick(Sender: TObject);
begin
  if idResultado <> 0 then
  begin
    dlGuardar.DefaultExt := 'bmp';
    dlGuardar.Filter := 'Fichero Bitmap (*.bmp)|*.bmp';
    if dlGuardar.Execute then
      SendMessage(idResultado, WM_CAP_SAVEDIB, 0, longint(pchar(dlGuardar.FileName)));
  end;
end;

procedure TformMenuPrincipal.bIniciarCamaraClick(Sender: TObject);
begin
  idResultado := capCreateCaptureWindowA('My Own Capture Window',
      WS_CHILD or WS_VISIBLE,  pImagen.Left, pImagen.Top, pImagen.Width,
      pImagen.Height, formMenuPrincipal.Handle, 0);
  if idResultado <> 0 then
  begin
    SendMessage(idResultado, WM_CAP_DRIVER_CONNECT, 0, 0);
    bIniciarCamara.Enabled := false;
    bDetener.Enabled := true;
    bCapturarFrame.Enabled := true;
    bGuardarImagen.Enabled := true;
    bGuardarVideo.Enabled := true;
  end
  else
  begin
    bDetener.Enabled := false;
    bIniciarCamara.Enabled := True;
    bCapturarFrame.Enabled := false;
    bGuardarVideo.Enabled := false;
  end;
end;

procedure TformMenuPrincipal.bGuardarVideoClick(Sender: TObject);
//var
//  segundos : integer;
begin
  if idResultado <> 0 then
  begin
    dlGuardar.DefaultExt := 'avi';
    dlGuardar.Filter := 'Fichero AVI (*.avi)|*.avi';
    if dlGuardar.Execute then
    begin
      capturandoAVI := true;
      try
        //segundos := strtoint(InputBox('Segundos a capturar',
        //    'Introduzca los segundos a capturar:', '10'));
        SendMessage(idResultado, WM_CAP_FILE_SET_CAPTURE_FILEA, 0,
            Longint(pchar(dlGuardar.FileName)));
        SendMessage(idResultado, WM_CAP_SEQUENCE, 0, 0);
      except
        MessageDlg('Debe especificar un nmero de segundos vlido.',
            mtError, [mbok], 0);
      end;
    end;
  end;  
end;

procedure TformMenuPrincipal.bDetenerClick(Sender: TObject);
begin
  if idResultado <> 0 then
  begin
    SendMessage(idResultado, WM_CAP_DRIVER_DISCONNECT, 0, 0);
    idResultado := 0;
    bDetener.Enabled := false;
    bCapturarFrame.Enabled := false;
    bGuardarImagen.Enabled := false;
    bGuardarVideo.Enabled := false;
    bIniciarCamara.Enabled := true;
  end;
end;

procedure TformMenuPrincipal.bCapturarFrameClick(Sender: TObject);
var
  i : integer;
begin
  if idResultado <> 0 then
    for i := 0 to 100 do
    begin
      SendMessage(idResultado, WM_CAP_GRAB_FRAME, 0, 0);
    end;
end;


procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  bDetenerClick(Self);
end;

procedure TformMenuPrincipal.bCerrarClick(Sender: TObject);
begin
  close;
end;

end.
